import std.stdio;
import std.file;
import std.string;

import opengl;
import openglu;
import glee;
import gleeFuncDef;

class Fpmgr {
    this() {
        expand_();
    }

    char[] fpname(int i) {
        return format("fp/%d.fp", i);
    }
    char[] fpname() {
        return fpname(index);
    }

    char[] get() {
        return cast(char[])std.file.read(fpname());
    }

    void copy() {
        int i = index;
        expand_();
        index = i;
        char[] from = fpname();
        char[] to = fpname(max+1);
        writefln("%s to %s", from, to);
        std.file.copy(from, to);
        max++;
    }

    void reload() {
        stop();
        load();
    }

    void load() {
        char[] fprog = get();
        glEnable(GL_FRAGMENT_PROGRAM_ARB);
        glGenProgramsARB(1, &fshader);
        glBindProgramARB(GL_FRAGMENT_PROGRAM_ARB, fshader);
        glProgramStringARB(GL_FRAGMENT_PROGRAM_ARB,
                           GL_PROGRAM_FORMAT_ASCII_ARB,
                           fprog.length, fprog.ptr);
        printf("%s\n", gluErrorString(glGetError()));
    }

    void stop() {
        glDeleteProgramsARB(1, &fshader);
    }

    void next() {
        index++;
        if (!std.file.exists(fpname())) index = 0;
    }

    void prev() {
        index--;
        if (index < 0) {
            expand_();
            index = max;
        }
    }

    private void expand_() {
        index = max;
        while (true) {
            max = index;
            next();
            if (index == 0) break;
        }
    }

    uint fshader;
    int index;
    int max;
}
