private import std.math;
private import std.random;
private import std.date;
private import myio;
private import rand;

const float SQRT_2 = 1.41421356;

float rtod(float a) {
	return a / std.math.PI * 180;
}

float dtor(float a) {
	return a * std.math.PI / 180;
}

private Rand genRand;
static this() {
    genRand = new Rand();
}

int rnd(int x) {
	return genRand.nextInt(x);
}

float rnd(float x) {
    return genRand.nextFloat(x);
}

float length2(float x, float y) {
	return x*x+y*y;
}

float length(float x, float y) {
	return std.math.sqrt(length2(x, y));
}

float distance2(float x1, float y1, float x2, float y2) {
	return length2(x2-x1, y2-y1);
}

float distance(float x1, float y1, float x2, float y2) {
	return std.math.sqrt(distance2(x1, y1, x2, y2));
}

int length2(int x, int y) {
	return x*x+y*y;
}

int distance2(int x1, int y1, int x2, int y2) {
	return length2(x2-x1, y2-y1);
}

float relAngle(float angle) {
	while (angle > std.math.PI) angle -= 2*std.math.PI;
	while (angle <= -std.math.PI) angle += 2*std.math.PI;
	return angle;
}

float angle(float x, float y) {
	return std.math.atan2(x, y);
}

float angle(float x1, float y1, float x2, float y2) {
	return std.math.atan2(x2-x1, y2-y1);
}

void normalize(inout float x, inout float y) {
	float d = length(x, y);
	x /= d;
	y /= d;
}

